"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PatchPackageJson = void 0;
const promises_1 = require("fs/promises");
const chalk_1 = __importDefault(require("chalk"));
const path = __importStar(require("path"));
const detect_indent_1 = __importDefault(require("detect-indent"));
const Logger_1 = require("../common/Logger");
const utils_1 = require("../common/utils");
const BaseCommand_1 = require("./BaseCommand");
class PatchPackageJson extends BaseCommand_1.BaseCommand {
    execute() {
        return __awaiter(this, void 0, void 0, function* () {
            const packagePath = path.join(process.cwd(), 'package.json');
            const packageString = (yield (0, promises_1.readFile)(packagePath)).toString();
            const indent = (0, detect_indent_1.default)(packageString).indent || '  ';
            const packageJson = JSON.parse(packageString);
            const minorVersion = (0, utils_1.getSpfxMinorVersion)();
            let version = `~1.${minorVersion}.0`;
            const dependency = 'spfx-fast-serve-helpers';
            if ((0, utils_1.isBeta)()) {
                version = `${version}-beta.0`;
            }
            if (packageJson.devDependencies[dependency] && packageJson.devDependencies[dependency] !== version) {
                Logger_1.logger.warning(chalk_1.default.yellowBright('Your dependency \'' + dependency + '\' version \'' + packageJson.devDependencies[dependency] + '\' will be replaced with version \'' + version + '\''));
            }
            packageJson.devDependencies[dependency] = version;
            packageJson.scripts = packageJson.scripts || {};
            if (packageJson.scripts['serve']) {
                Logger_1.logger.warning(chalk_1.default.yellowBright('Your npm \'serve\' command will be replaced.'));
                Logger_1.logger.newLine();
            }
            packageJson.scripts['serve'] = 'fast-serve';
            yield (0, promises_1.writeFile)(packagePath, JSON.stringify(packageJson, null, indent));
            Logger_1.logger.success(chalk_1.default.blueBright('Updated package.json.'));
            Logger_1.logger.newLine();
        });
    }
}
exports.PatchPackageJson = PatchPackageJson;
//# sourceMappingURL=PatchPackageJson.js.map