"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logger = void 0;
const log_symbols_1 = __importDefault(require("log-symbols"));
class Logger {
    constructor() {
        const args = process.argv.slice(2);
        const silent = args.indexOf('--silent') !== -1;
        if (silent) {
            this.logger = () => 0;
        }
        else {
            this.logger = console.log;
        }
    }
    success(message) {
        this.logger(log_symbols_1.default.success, message);
    }
    log(message) {
        this.logger(message);
    }
    warning(message) {
        this.logger(log_symbols_1.default.warning, message);
    }
    info(message) {
        this.logger(log_symbols_1.default.info, message);
    }
    newLine() {
        this.logger('');
    }
}
exports.logger = new Logger();
//# sourceMappingURL=Logger.js.map