"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.spawnProcess = exports.isBeta = exports.getSpfxMinorVersion = exports.getTemplatesPath = void 0;
const path = __importStar(require("path"));
const cross_spawn_1 = require("cross-spawn");
const packagePath = path.join(process.cwd(), 'package.json');
const dependecyToCheck = '@microsoft/sp-build-web';
const packageJson = require(packagePath);
function getTemplatesPath(fileName) {
    const basePath = 'templates/';
    return path.join(__dirname, '..', basePath + fileName);
}
exports.getTemplatesPath = getTemplatesPath;
function getSpfxMinorVersion() {
    let version = packageJson.devDependencies[dependecyToCheck];
    if (version.indexOf('~') === 0 || version.indexOf('^') === 0) {
        version = version.substr(1);
    }
    return parseInt(version.split('.')[1]);
}
exports.getSpfxMinorVersion = getSpfxMinorVersion;
function isBeta() {
    const version = packageJson.devDependencies[dependecyToCheck];
    return version.indexOf('-beta') !== -1 || version.indexOf('-rc') !== -1;
}
exports.isBeta = isBeta;
function spawnProcess(program, args, env) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            const proc = (0, cross_spawn_1.spawn)(program, args, {
                stdio: 'inherit',
                env: env || process.env
            });
            process.on('SIGTERM', () => proc.kill('SIGTERM'));
            process.on('SIGINT', () => proc.kill('SIGINT'));
            process.on('SIGBREAK', () => proc.kill('SIGBREAK'));
            process.on('SIGHUP', () => proc.kill('SIGHUP'));
            proc.on('exit', (code, signal) => {
                let crossEnvExitCode = code;
                if (crossEnvExitCode === null) {
                    crossEnvExitCode = signal === 'SIGINT' ? 0 : 1;
                }
                if (crossEnvExitCode === 1) {
                    reject();
                }
                else {
                    resolve();
                }
            });
        });
    });
}
exports.spawnProcess = spawnProcess;
//# sourceMappingURL=utils.js.map